<?php
include WP_AJAX_PRO_PATH . 'admin/sections/navigation.php';
include WP_AJAX_PRO_PATH . 'admin/includes/common.php';

$mode = (isset($_POST['mode'])) ? $_POST['mode'] : '';

if($mode == 'clone') {
    $form_id = (int)$_POST['form_id'];
    $new_form_id = $form->cloneData($form_id);
}

if($mode == 'export_messages') {
    include $afp_conf['local']['path_to_afp_admin'].'includes/classes/class.manage.messages.php';
    
    $manage_messages = new Manage_Messages($afp_conf, $afp_db);
    $manage_messages->export_messages();
}

include WP_AJAX_PRO_PATH. 'admin/includes/classes/class.pagination.php';

$pagination = new Pagination($afp_db);

$pagination->main_url = $conf['url']['path_to_manage_forms'];
$pagination->max_results = 10; // Results per page

$forms_query_all = "SELECT id, name, description FROM `".$afp_conf['db']['prefix']."forms` ";

$keyword = filter_input(INPUT_POST | INPUT_GET, 'keyword', FILTER_SANITIZE_SPECIAL_CHARS);
$search_by = (isset($_REQUEST['search_by'])) ? $_REQUEST['search_by'] : '';

if($keyword && $search_by) {
    
    $keyword = trim($keyword);
    
    $q_part = "WHERE ";
     
    switch ($search_by) { 
    	case 'form_id':
            $q_part .= "id='".(int)$keyword."'";
    	break;
    
    	case 'form_name':
            $q_part .= "name REGEXP '".$keyword."'";
    	break;
    
    	case 'form_description':
            $q_part .= "description REGEXP '".$keyword."'";
    	break;
    }
} else {
    $q_part = '';
}

$forms_query_all .= $q_part." ORDER BY date_added DESC";

$pagination->all_query = $forms_query_all;

$pagination_result = $pagination->Generate();

$pagination_html = $pagination_result['pagination'];
$db_current_forms_query = $pagination_result['current_query'];

$forms = $afp_db->getAll($db_current_forms_query);


if(isset($output)) {
    if( ! $output['success'] ) {
        echo '<div class="note_error">'.$output['message'].'</div>';
    }
}
?>

    <div style="margin: 28px 0;">
     <h2 style="float:left; margin: 0;">Manage Forms</h2>
        
        <form name="search_form" action="admin.php" method="get">
        <div style="margin: 0 0 15px 0; float:right; width:auto;">Keyword: <input class="input-medium" type="text" name="keyword" value="<?php echo $keyword; ?>" />&nbsp; by <strong>Form</strong>
        &nbsp;
        
        <select name="search_by">
            <option <?php if($search_by == 'form_id') { echo 'selected="selected"'; } ?> value="form_id">ID</option>
            <option <?php if($search_by == 'form_name') { echo 'selected="selected"'; } ?> value="form_name">Name</option>
            <option <?php if($search_by == 'form_description') { echo 'selected="selected"'; } ?> value="form_description">Description</option>
        </select>
        &nbsp;
        
        <input type="hidden" name="page" value="afp-manage-forms" />
        
        <input class="fancy-button-base light" style="font-size:13px;" type="submit" name="search" value="Search" /></div>
        </form>
    </div>
    
    <div style="clear:both;"></div>
    
    <?php    
    if( ! empty($forms) ) {
    ?>
    
        <table class="fields" width="100%">
        
            <tr class="heading">
                <td width="5%" style="border:none; background-color:white !important;">&nbsp;</td>
                <td><strong>ID</strong></td>
                <td width="25%"><strong>NAME</strong></td>
                <td width="37%"><strong>DESCRIPTION</strong></td>
                <td><strong>MANAGE</strong></td>
            </tr>
            
            <?php                    
            foreach($forms as $v_value) {
                
                $form_id = $v_value['id'];
                $name = $v_value['name'];
                $description = $v_value['description'];
                
                if($description) {
                    if(strlen($description) < $afp_conf['short_desc_chars']) {
                        $description_short = $description;
                        $is_shorten = false;
                    } else {
                        $is_shorten = true;
                        $description_short = substr($description, 0, $afp_conf['short_desc_chars']).'...';
                    }
                    
                    $description_full = $description;
                    
                } else {
                    $is_shorten = false;
                    $description_short = '<em>none</em>';
                    $description_full = '';
                }
            ?>
                <tr class="list_row" id="f-r-<?php echo $form_id; ?>">
                    <td><a target="_blank" href="<?php echo $afp_conf['url']['path_to_script']; ?>standalone/generate.php?form_id=<?php echo $form_id; ?>" title="Preview"><img src="<?php echo $afp_conf['url']['path_to_afp_admin']; ?>includes/images/icons/show-24x24.png" width="24" height="24" alt="" border="0" /></a></td>
                    <td><?php echo $form_id; ?></td>
                    <td id="name-<?php echo $form_id; ?>"><?php echo $name; ?> <?php if(isset($new_form_id) && $new_form_id == $form_id) { echo ' - <font color="green">form created successfully</font>'; } ?></td>
                    <td id="description-<?php echo $form_id; ?>"><?php if($is_shorten) { ?><span title="<?php echo $description_full; ?>"><?php } ?><?php echo $description_short; ?><?php if($is_shorten) { ?></span><?php } ?></td>
                    <td><span class="full_desc" id="description-full-<?php echo $form_id; ?>"><?php echo $description_full; ?></span><a class="manage_fields" href="<?php echo $afp_conf['url']['path_to_manage_forms'].'&afp_module=edit_form_fields&form_id='.$form_id; ?>">Fields</a><a class="edit_config" href="<?php echo $afp_conf['url']['path_to_manage_forms'].'&afp_module=edit_form_config&form_id='.$form_id; ?>">Configs</a><a class="edit_info" href="#" rel="<?php echo $form_id; ?>">Info</a><a class="messages" href="<?php echo $afp_conf['url']['path_to_manage_forms'].'&afp_module=manage_messages&form_id='.$form_id; ?>">Messages</a><a class="more" href="#" rel="<?php echo $form_id + 100; ?>">More</a></td>
                </tr>    
            <?php
            }
            ?>
                    
        </table>

<script type="text/javascript">

<?php
    foreach($forms as $valoare) {
        $form_id = $valoare['id'];
        $form_title = $valoare['name'];
    ?>
        linkset[<?php echo $form_id + 100; ?>]  = '<a class="clone" rel="<?php echo $form_id; ?>" title="<?php echo str_replace("'","\'", $form_title); ?>" href="#">Clone</a>';
        linkset[<?php echo $form_id + 100; ?>] += '<a class="delete_f" rel="<?php echo $form_id; ?>" title="<?php echo str_replace("'","\'", $form_title); ?>" href="#">Delete</a>';
    <?php
    }
?>

        </script>
        
	<br />

        <div id="afp_pg"><?php echo $pagination_html; ?></div>

    <div class="bottom_nav" align="right">
        <a id="export_messages_btn" class="export_all" href="#"><strong>Export All Messages</strong></a> &nbsp;&nbsp;&nbsp;&nbsp; <a class="integrate" href="#"><strong>Integrate a Form (within the list above) Into My Web Page</strong></a>    
    </div>    
    
    <?php } else { ?>
    
    <div>
    
    <?php
    if($keyword) {
    ?>
        No forms were found matching your search criteria.
    <?php
    } else {  
    ?>
        There are no forms to manage. Click <a href="admin.php?page=afp-add-form"><strong>here</strong></a> to add one.
    <?php
    }
    ?>
    </div>
    
    <?php } ?>
    
    <!-- [START] EDIT FORM INFORMATION DIALOG -->
    <div id="edit-form-info" title="Edit Form Information">
    	<form id="edit_form">
        	<fieldset>
            
            <div id="response_note"></div>
        
        		<label for="name">Name</label>
        		<input name="name" id="name" type="text" class="text ui-widget-content ui-corner-all" />
                
        		<label for="email">Description</label>
        		<textarea name="description" id="description" rows="3" cols="2" class="text ui-widget-content ui-corner-all"></textarea>
            </fieldset>
            
            <input type="hidden" name="form_id" id="form_id" value="" />
               
    	</form>
    </div>
    <!-- [END] EDIT FORM INFORMATION DIALOG -->
    
    <!-- [START] EXPORT MESSAGES -->
    <div id="export-messages-box" title="Export All Forms' Messages">
    	<form id="export_messages_form" action="" method="post">
            <input type="hidden" name="mode" value="export_messages" />
            
            <em>* If you'd like to include the 'Date Recorded' column tick the checkbox below and input the title as well as the date format.</em>
        	<fieldset>
                
                <div style="margin: 20px 0;">
                    <input type="checkbox" name="add_date_recorded" id="add_date_recorded_checkbox_2_msg" checked="checked" /> <label for="add_date_recorded_checkbox_2_msg">Include 'Date Recorded' column?</label><br />
                    <div class="date_recorded_title_area">
                        <ul>
                            <li>Column Title: <input type="text" name="date_recorded_column_title" value="Date Recorded" /></li>
                            <li>Date Format: <input type="text" name="date_recorded_format" value="d-F-Y H:i" /> <small><a target="_blank" href="http://php.net/manual/en/function.date.php">See format options here</a></small></li>
                            <li><small>Example: <em>d-F-Y H:i</em> would be like <em><?php echo date('d-F-Y H:i'); ?></em></small></li>
                        </ul>
                    </div>
                </div>
                
            </fieldset>                 
    	</form>
    </div>
    <!-- [END] EXPORT SUBMITTED FIELDS -->
    
    <!-- [START] INTEGRATE FORM DIALOG -->
    <div id="select-integration" title="How to Integrate the Form?">
    	<form id="select_integration">
        	<fieldset>

                <div style="width:100%;">
                    
                    <div id="no_form_alert"></div>
                        
                        <p>Form:</p>
                        <select style="min-width:160px; max-width: 265px;" id="integration_form_id" name="form_id">
                            <?php                            
                            foreach($forms as $v_value) {
                                echo '<option value="'.$v_value['id'].'">'.$v_value['name'].'</option>'."\n";
                            }
                            ?>
                        </select>  
                    
                    <p>Integration Method:</p>
                    <select id="integration_method" name="integration_method">
                            <option value="post_page">Post/Page</option>
                            <option value="outside_post_page">Custom Location (outside Post/Page)</option>
                            <option value="widget">Widget (Sidebar)</option>
                            <option value="lightbox">Lightbox</option>
                            <option value="slide_in_top">Slide-In Top</option>
                            <option value="slide_in_left">Slide-In Left</option>
                            <option value="iframe">iFrame</option>
                    </select>                    
                    
                </div>
                                               
            </fieldset>
                           
    	</form>
    </div>
    <!-- [END] INTEGRATE FORM DIALOG -->

    <!-- Clone Form -->
    <form name="clone_form" id="clone_form" action="" method="post">
        <input type="hidden" name="mode" value="clone" />    
        <input type="hidden" name="form_id" id="clone_from_form_id" value="" />
    </form>
<?php
include (WP_PLUGIN_DIR . '/wp-ajax-form-pro/admin/sections/footer.php');
?>