<?php
define('AFP_STANDALONE', 1);

$path_to_wp_site_root = dirname(dirname(dirname(dirname(dirname(__FILE__)))));

if(defined('AFP_WP_CONFIG_ONLY')) {
    define('ABSPATH', dirname(__FILE__).'/includes/');
    require_once ABSPATH.'wp-settings.php';
    require_once( $path_to_wp_site_root .'/wp-config.php' );
    $connectAfpDB = true;
} else {
    require_once( $path_to_wp_site_root .'/wp-load.php' );    
    $connectAfpDB = false;
}

$local_path_to_afp = dirname ( dirname(__FILE__) ).'/';
//echo $local_path_to_afp;

include_once $local_path_to_afp.'base.php';

include_once $local_path_to_afp.'admin/includes/classes/class.application.php';
$afp_app = new Afp_Application;

include_once $local_path_to_afp.'admin/includes/classes/class.database.php';
//echo '<pre>'; print_r($afp_conf['db']); echo '</pre>'; exit;

// Initialize the database connection
$afp_db = new Afp_DB($afp_conf['db']['host'], $afp_conf['db']['user'], $afp_conf['db']['pass'], $afp_conf['db']['name'], $connectAfpDB);

// Include the Manage Form Fields Class
include_once $local_path_to_afp.'admin/includes/classes/class.manage.forms.fields.php';
$afp_form_fields = new Manage_Forms_Fields($afp_conf, $afp_db);

if($get_form_info == 1) {
    // Include the Manage Form Fields Class
    include_once $local_path_to_afp.'admin/includes/classes/class.manage.forms.php';
    
    $afp_manage_forms = new Manage_Forms($afp_conf, $afp_db);    
}

// Include the main script's class
include 'includes/class.ajax.form.pro.php';

// Include the misc. functions class (it will extend the Ajax_Form_Pro class)
include 'includes/class.misc.functions.php';

$afp = new Misc_Functions($afp_form_fields, $afp_db);

// Assign the configuration
//echo '<pre>'; print_r($afp_conf); echo '</pre>';
$afp->mAfpConf = $afp_conf;
$afp->conf = $afp_conf;
$afp->app = $afp_app;

if($afp_form_id) {
    if( ! $afp->CheckFormStatus($afp_form_id) ) {
        exit;
    }
}

if( ! isset($do_not_load_smarty) && $do_not_load_smarty != 1 ) {
    /*
    -------------------
    Initialize Smarty
    -------------------
    */
    if(AFP_ENABLE_PHP_INSIDE_SMARTY == 1) {
        require 'includes/smarty/SmartyBC.class.php';
        $afp_smarty = new SmartyBC();
    } else {
        require 'includes/smarty/Smarty.class.php';
        $afp_smarty = new Smarty();		
    }

    $afp_smarty->setTemplateDir($path_to_afp_templates)
               ->setCompileDir($afp_conf['local']['path_to_app'] . 'includes/smarty/templates_c')
               ->setCacheDir($afp_conf['local']['path_to_app'] . 'includes/smarty/cache')
               ->setPluginsDir($afp_conf['local']['path_to_app'] . 'includes/smarty/plugins')
               ->setConfigDir($afp_conf['local']['path_to_app'] . 'includes/smarty/configs');
        
    $afp->mSmarty = $afp_smarty;
    $afp->mSmarty->assign('c', $afp_conf);
     
    /* --------------------- */
}


$_POST = (!empty($_POST)) ? $afp->FilterArray($_POST) : $_POST;

/* 
---------------------------------------------------------
USE THE FOLLOWING CODE IN CASE A 'FORM ID' IS REQUESTED
---------------------------------------------------------
*/

if(isset($afp_form_id) && is_numeric($afp_form_id) && !isset($afp_forms)) {
    $afp_forms = array($afp_form_id);
}
//echo $get_form_info;
//echo '<pre>'; print_r($afp_forms); echo '</pre>';

if( ($get_form_info == 1) && is_array($afp_forms) ) {
    //echo 1;
    $AfpMyForms = array();
    
    foreach($afp_forms as $afp_form_id) {
        $afp_f_info = $afp_manage_forms->getFormData($afp_form_id);
        
        //echo '<pre>'; print_r($f_info); echo '</pre>';
         
        $afp_form_title = $afp_f_info['title'];
        $afp_custom = $afp_f_info['custom'];
         
        $afp_area_width = $afp_f_info['area_width'];
        
        $afp_layout_name = substr($afp_f_info['file_template'], 0, -4);
         
        $AfpMyForms[$afp_form_id] = array(
            'layout'     => $afp_layout_name,
            'css'        => $afp_f_info['file_css'],
            'area_width' => $afp_area_width
        );
                  
        if($afp_custom == 1) {
            $AfpMyForms[$afp_form_id]['custom'] = array(
                'template' => $afp_layout_name.'.tpl',
                'style'    => $afp_layout_name.'.css.php'
            );
        }
    }
     
    $afp->mMyForms = $AfpMyForms;    
}
//echo '<pre>'; print_r($afp->mMyForms); echo '</pre>';
?>