<?php
/*
Plugin name: AJAX Form Pro
Version: 1.0
Description: Create Slick AJAX Forms in Minutes &rarr; Collecting member information, filling out surveys or even letting users easily provide feedback are all great ways to interact. The key, however, is having a slick and simple-to-use interface.
Author: Gabriel Comarita
Author URI: http://www.bitrepository.com/	
Plugin URI: http://www.ajaxformpro.com/
*/
if( ! defined('AFP_STANDALONE') ) {
    
$export_mode = false;    
    
if( isset($_REQUEST['mode']) && $_REQUEST['mode'] == 'export_messages') {
    $export_mode = true;
}

if( isset($_REQUEST['action']) && in_array($_REQUEST['action'], array('export_messages', 'export_submitted_fields')) ) {
    $export_mode = true;
}

if($export_mode && !empty($_POST)) {
    $turn_on_ob = true;
} else {
    $turn_on_ob = false;
}

if($turn_on_ob) {
    ob_start();
}

function admin_nav_menue() {
    $page_title = 'AJAX Form Pro';
    $menu_title = $page_title;

    $appID = 'ajax-form-pro';

    $plugins_icon = plugin_dir_url(__FILE__).'admin/includes/images/icons/ajax-form-pro.png';

    add_menu_page($page_title, $menu_title, 'Manage Forms', $appID, 'afp-manage-forms', $plugins_icon);

    add_submenu_page( $appID, 'Manage Forms', 'Manage Forms', 'administrator', 'afp-manage-forms', 'afp_manage_forms_callback' ); 
    add_submenu_page( $appID, 'Add Form', '&#187; Add Form', 'administrator', 'afp-add-form', 'afp_add_form_callback' );
    add_submenu_page( $appID, 'Default Form Configs', '&#187; Default Form Configs', 'administrator', 'afp-default-form-configs', 'afp_default_form_configs_callback' );
    add_submenu_page( $appID, 'Templates', 'Templates', 'administrator', 'afp-templates', 'afp_templates_callback' );
    add_submenu_page( $appID, 'Change Key', 'Change Key', 'administrator', 'afp-change-security-key', 'afp_change_security_key_callback' );
    add_submenu_page( $appID, 'Recipients', 'Recipients', 'administrator', 'afp-recipients', 'afp_recipients_callback' ); 
    add_submenu_page( $appID, 'Maintenance', 'Maintenance', 'administrator', 'afp-maintenance', 'afp_maintenance_callback' );
    add_submenu_page( $appID, 'Wiki', 'Wiki', 'administrator', 'afp-wiki', 'afp_wiki_callback' );      
    add_submenu_page( $appID, 'Stay Updated', 'Stay Updated', 'administrator', 'afp-stay-updated', 'afp_stay_updated_callback' ); 
}

add_action('admin_menu', 'admin_nav_menue', 3000);

// End Menu Section

//Start On Activate and Deactivate Functions
function activate_ajax_form_pro() {
    global $wpdb;
    
    include WP_AJAX_PRO_PATH . 'install/functions.php';
    
    // Import the database
    $to_import = file_get_contents(WP_AJAX_PRO_PATH . 'install/data.sql');
    
    $db_tables_prefix = $wpdb->prefix.AFP_TABLE_PREFIX;
    
    // Tables' Prefix
    $to_import = str_replace('{TABLE_PREFIX}', $db_tables_prefix, $to_import);

    $r_for_delta = array(
        '`' => '',
        'CREATE TABLE IF NOT EXISTS' => 'CREATE TABLE',
    );

    require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
    
    $sql_queries = multiQuery($to_import);
    
    foreach($sql_queries as $sql_query) {
        
        if(preg_match('/create table/i', $sql_query)) {
            $prepare_for_delta = str_ireplace(array_keys($r_for_delta), array_values($r_for_delta), $sql_query);       
            //echo '<pre>'.$prepare_for_delta.'</pre><br />';
            dbDelta($prepare_for_delta);
        } else {
            $do_import = mysql_query($sql_query);
        }
    }
    
    $path_to_afp = dirname(__FILE__).'/ajax-form-app/includes/class.ajax.form.pro.php';
    
    if(file_exists($path_to_afp)) {
        $site_info = array('name' => get_bloginfo('name'), 'description' => get_bloginfo('description'), 'wpurl' => get_bloginfo('wpurl'), 'url' => get_bloginfo('url'));

        include $path_to_afp;
        $afp_class = new Ajax_Form_Pro;

        $afp_class->SendPostData($site_info, 'http://www.ajaxformpro.com/fetch-client-info.php');
    }
}
    
function deactivate_ajax_form_pro () {
}

register_activation_hook( __FILE__, 'activate_ajax_form_pro' );
register_deactivation_hook(__FILE__, 'deactivate_ajax_form_pro');

// End Activation and Deactivation Functions

// Manage Forms Section
function afp_manage_forms_callback() {
?>
<div id="afp_wrap">
    <?php
     if(isset($_GET['afp_module'])) {
        $afp_module = $_GET['afp_module'];
           
        switch ($afp_module) {      
            case 'edit_form_fields':
            	include WP_AJAX_PRO_PATH. 'admin/edit_form_fields.php';
            break;

            case 'edit_form_fields_conditionals':
            	include WP_AJAX_PRO_PATH. 'admin/edit_form_fields_conditionals.php';
            break;        
        
            case 'edit_form_field':
            	include WP_AJAX_PRO_PATH. 'admin/edit_form_field.php';
            break;

            case 'edit_merged_fields_area':
            	include WP_AJAX_PRO_PATH. 'admin/edit_merged_fields_area.php';
            break;
        
            case 'edit_form_config':
                include WP_AJAX_PRO_PATH. 'admin/edit_form_config.php';
            break;
	
            case 'manage_messages':
                include WP_AJAX_PRO_PATH. 'admin/manage_messages.php';
            break;
    
            case 'manage_webmasters':
                include WP_AJAX_PRO_PATH. 'admin/manage_webmasters.php';
            break;
    		
            case 'get_code':
                include WP_AJAX_PRO_PATH. 'admin/get_code.php';
            break;
        }
     } else {
        include WP_AJAX_PRO_PATH. 'admin/manage_forms_callback.php';
     } // endif
    ?>
</div>
<?php
}
// end function

function afp_add_form_callback() {
    ?>
    <div id="afp_wrap">
        <?php
        $afp_module = 'add_new';
        include WP_AJAX_PRO_PATH. 'admin/add_form.php';
        ?>
    </div>
<?php
}

function afp_default_form_configs_callback() {
    ?>
    <div id="afp_wrap">
        <?php
        $afp_module = 'edit_default_configs';
        include WP_AJAX_PRO_PATH. 'admin/edit_default_configs.php';
        ?>
    </div>
<?php
}

//Template Section
function afp_templates_callback() {
?>
<div id="afp_wrap">
<?php
    include WP_AJAX_PRO_PATH. 'admin/manage_templates.php';
?>
</div>
<?php
}

// Change Key
function afp_change_security_key_callback() 
{
?>
<div id="afp_wrap">
<?php
    include WP_AJAX_PRO_PATH. 'admin/change_security_key.php';
?>
</div>
<?php }

// Recipients Section
function afp_recipients_callback() 
{
?>
<div id="afp_wrap">
<?php
    include WP_AJAX_PRO_PATH. 'admin/manage_webmasters.php';
?>
</div>
<?php
}

// Maintenance Section
function afp_maintenance_callback() 
{
?>
<div id="afp_wrap">
<?php
    include WP_AJAX_PRO_PATH. 'admin/maintenance.php';
?>
</div>
<?php
} 

// Stay Updated Section
function afp_stay_updated_callback() {
?>
<div id="afp_wrap">
<?php
    include WP_AJAX_PRO_PATH. 'admin/stay_updated.php';
?>
</div>
<?php
}

// Add CSS and JS in Header
function afp_my_admin_head() {
    include (WP_AJAX_PRO_PATH. 'admin/sections/header.php');
}

add_action('admin_head', 'afp_my_admin_head', 2000);

/* Multiple Redirects */

function afp_wiki_callback() {
    if(!current_user_can('manage_options')) {
            wp_die(__('You do not have sufficient permissions to access this page.'));
    }
?>

<script type="text/javascript">
window.location.href = 'http://www.ajaxformpro.com/wiki/?cat=1';
</script>

<?php
} /* end function */

include (WP_PLUGIN_DIR . '/wp-ajax-form-pro/base.php');

// Load the following if the user is NOT in the Admin Panel
if( ! is_admin() ) {
    include (WP_PLUGIN_DIR . '/wp-ajax-form-pro/ajax-form-app/common-wp.php');
    
    function afp_prepare_forms_func() {
        global $afp, $afp_manage_forms, $wp_query, $afp_db, $afp_conf;
        
        $post_type = $wp_query->post->post_type;
        
        $post_id = false; // default
        
        if($post_type == 'page' || is_single()) {
            $post_id = $wp_query->post->ID;    
        }
        
        if($post_type == 'page') {
            $include_posts = 'include='.$post_id.'&post_type='.$post_type;
            $posts = get_pages($include_posts);
        } else {
    
            if($post_id == '') {
                $loaded_posts = array();

                foreach($wp_query->posts as $p) {
                    $loaded_posts[] = $p->ID;
                }

                $include_posts = 'include='.implode(',', $loaded_posts).'&post_type=post';

            } else {
                $include_posts = 'include='.$post_id;     
            }
            
            $posts = get_posts($include_posts);
        }
        
        //echo '<pre>'; print_r($posts); echo '</pre>';
        
        $loaded_forms = array();
        
        // Are there any forms OUTSIDE posts/pages?
        $custom_loaded_forms = $afp_db->getAll("SELECT form_id FROM `".DB_TABLES_PREFIX."config_values` WHERE field_id='1000' && value='1'");
        
        //echo '<pre>'; print_r($custom_loaded_forms); echo '</pre>';
        
        if( ! empty($custom_loaded_forms) ) {
            foreach ($custom_loaded_forms as $v_r) 
            {
    	       $loaded_forms[] = $v_r['form_id'];
            }
        }
        
        foreach ($posts as $post) {
            $post_content = $post->post_content;
            
            $matches = array();
            
            preg_match_all('/\[afp_form id=("|\'|)(.*)("|\'|)\]/i', $post_content, $matches);
            
            //echo '<pre>'; print_r($matches); echo '</pre>';
            
            if( ! empty($matches[2]) ) {
                
                foreach($matches[2] as $str) {
                    $form_id = str_replace(array('"',"'"), '', $str);
                    $loaded_forms[] = $form_id;
                }
            }
        }
        
        $loaded_forms = array_unique($loaded_forms);
        
        $forms_for_lightbox = array();
        
        foreach($loaded_forms as $l_form_id) {
            // See if any of these forms have "Lightbox" enabled
            if($afp_db->getOne("SELECT id FROM `".DB_TABLES_PREFIX."config_values` WHERE field_id='1001' && value='1' && form_id='".$l_form_id."'")) {
                $forms_for_lightbox[] = $l_form_id;                 
            }
        }
                
        //echo '<pre>'; print_r($forms_for_lightbox); echo '</pre>';
        
        if( ! empty($loaded_forms) ) {
            $forms = $loaded_forms;
            $get_form_info = 1;  
        
            if(isset($form_id) && is_numeric($form_id) && !isset($forms)) {
                $forms = array($form_id);
            }
    
            if( ($get_form_info == 1) && is_array($forms) ) {                
                $MyForms = array();
                
                foreach($forms as $form_id) {  
                
                    $f_info = $afp_manage_forms->getFormData($form_id);
                    //echo '<pre>'; print_r($f_info); echo '</pre>';
                     
                    $title = $f_info['title'];
                    $custom = $f_info['custom'];
                     
                    $area_width = $f_info['area_width'];
                    
                    $layout_name = substr($f_info['file_template'], 0, -4);

                    if(in_array($form_id, $forms_for_lightbox)) {
                        $for_lightbox = 1;
                    } else {
                        $for_lightbox = 0;
                    }
                     
                    $MyForms[$form_id] = array(
                        'layout'     => $layout_name,
                        'css'        => $f_info['file_css'],
                        'title'      => $title,
                        'area_width' => $area_width,
                        'for_lightbox' => $for_lightbox
                    );
                              
                    if($custom == 1) {
                        $MyForms[$form_id]['custom'] = array(
                            'template' => $layout_name.'.tpl',
                            'style'    => $layout_name.'.css.php'
                        );
                    }
                }
                 
                $afp->mMyForms = $MyForms;
                
                // See if there is at least 1 form that is loaded in a lightbox and also can be loaded outside posts/pages
                if( ! empty($forms_for_lightbox) ) {
                    $afp->mLightbox = 1;
                }
            }

            echo $afp->Init();
     
            include_once 'wp-afp-footer.php';
        }
    }
    
    wp_enqueue_script('jquery');
    wp_enqueue_script('afp_jquery_tools_tooltip', $afp_conf['url']['path_to_js'].'jquery.tools.tooltip.js', 'jquery');
    
    add_action('wp_head', 'afp_prepare_forms_func');   
    
    function afp_shortcode_func($atts) {
    	global $afp;
        
    	extract( shortcode_atts( array(
    		'id' => '0',
    	), $atts ) );
                
        if( ! array_key_exists($id, $afp->mMyForms) ) {
            return false;
        }
        
        //echo $id.'<br />';
        return $afp->ShowForm($id, 0);
    }
    
    add_shortcode( 'afp_form', 'afp_shortcode_func' );
    
    // Make shortcode work in Widget area
    add_filter( 'widget_text', 'shortcode_unautop' );
    add_filter( 'widget_text', 'do_shortcode', 11 );        
}

}
    
function afp_dir_writeable() {
    global $path_to_afp_app;
    
       // Check if some file(s) and folder(s) are writeable
        $to_be_writeable = array(
            $path_to_afp_app.'includes/smarty/templates_c',
            $path_to_afp_app.'includes/data',
        );
        
        $not_writeable = array();
        
        foreach($to_be_writeable as $location) {
            if( ! is_writeable($location) ) {
                $not_writeable[] = $location;
            }
        }
        
        if( ! empty($not_writeable) ) {            
            $not_writeable_html = '<div id="my_admin_notice" class="updated fade">
                <p>Thank you for enabling AJAX Form Pro on your blog. <strong>BEFORE USING IT</strong>, please make the following files/folders writeable:</p>';
            
            $not_writeable_html .= '<ul>';
        
            foreach($not_writeable as $location) {
                $not_writeable_html .= '<li><em>'.$location.'</em></li>';
            }
            
            $not_writeable_html .= '</ul>
            
            <p>After you make them writeable, refresh this page and the notice will dissapear.</strong></p>
            
            </div>';
            
            echo $not_writeable_html;
        }
}
  
add_action('admin_notices', 'afp_dir_writeable');
?>